#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityDoubleElevenLotteryTicketShop.h"
std::auto_ptr<M_ActivityDoubleElevenLotteryTicketShop> M_ActivityDoubleElevenLotteryTicketShop::msSingleton(nullptr);

int M_ActivityDoubleElevenLotteryTicketShop::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityDoubleElevenLotteryTicketShopData* M_ActivityDoubleElevenLotteryTicketShop::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityDoubleElevenLotteryTicketShopData>& M_ActivityDoubleElevenLotteryTicketShop::GetMapData()
{
	return mMapData;
}

void M_ActivityDoubleElevenLotteryTicketShop::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityDoubleElevenLotteryTicketShop.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityDoubleElevenLotteryTicketShopData data;
		data.mID = element->IntAttribute("ID");
		data.mLotteryCount = element->IntAttribute("LotteryCount");
		data.mNeedCount = element->IntAttribute("NeedCount");
		data.mTicketCount = element->IntAttribute("TicketCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityDoubleElevenLotteryTicketShop Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDoubleElevenLotteryTicketShop::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityDoubleElevenLotteryTicketShop");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityDoubleElevenLotteryTicketShop");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityDoubleElevenLotteryTicketShopData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "LotteryCount", data.mLotteryCount);
		LuaCfgHelper::readInt(L, "NeedCount", data.mNeedCount);
		LuaCfgHelper::readInt(L, "TicketCount", data.mTicketCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityDoubleElevenLotteryTicketShop Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityDoubleElevenLotteryTicketShop::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityDoubleElevenLotteryTicketShop* M_ActivityDoubleElevenLotteryTicketShop::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityDoubleElevenLotteryTicketShop());
	}
	return msSingleton.get();
}

void M_ActivityDoubleElevenLotteryTicketShop::Release()
{
	msSingleton.reset(nullptr);
}
